//------------------------------------------------------------------
#property copyright "copyleft www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Gray
#property indicator_color2 Lime
#property indicator_color3 Lime
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern string  TimeFrame       = "Current time frame";
extern int     CCIperiod       = 50;
extern int     ATRperiod       = 5;
extern int     applied_price   = 5; 
extern bool    noIntermediate  = true;
extern bool    alertsOn        = false;
extern bool    alertsOnCurrent = true;
extern bool    alertsMessage   = true;
extern bool    alertsSound     = false;
extern bool    alertsEmail     = false;

//
//
//
//
//

double   Trend[];
double   TrendDoA[];
double   TrendDoB[];
double   TrendUpA[];
double   TrendUpB[];
double   Direction[];

int      timeFrame;
bool     calculateValue;
bool     returnBars;
string   indicatorFileName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0, Trend);
      SetIndexBuffer(1, TrendUpA);
      SetIndexBuffer(2, TrendUpB);
      SetIndexBuffer(3, TrendDoA);
      SetIndexBuffer(4, TrendDoB);
      SetIndexBuffer(5, Direction);
      

         //
         //
         //
         //
         //
                  
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //

   IndicatorShortName("SuperTrend "+timeFrameToString(timeFrame));    
   return(0);
}
int deinit()
{
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMax(Bars-counted_bars,Bars-1);
         if (returnBars) { Trend[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (!noIntermediate)
      {
         if (Direction[limit] == -1 && Direction[limit+1] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
         if (Direction[limit] ==  1 && Direction[limit+1] ==  1) CleanPoint(limit,TrendUpA,TrendUpB);
      }
      else
      {
         if (Direction[limit] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
         if (Direction[limit] ==  1) CleanPoint(limit,TrendUpA,TrendUpB);
      }         
      
      //
      //
      //
      //
      //
      
      for(int i=limit; i >= 0; i--)
      {
         double cciTrend  = iCCI(NULL, 0, CCIperiod, applied_price, i);
         
         //
         //
         //
         //
         //
         
         TrendDoA[i]  = EMPTY_VALUE;
         TrendDoB[i]  = EMPTY_VALUE;
         TrendUpA[i]  = EMPTY_VALUE;
         TrendUpB[i]  = EMPTY_VALUE;
         Trend[i]     = Trend[i+1];
         Direction[i] = Direction[i+1];
            if (cciTrend > 0) { Trend[i] = MathMax(Low[i]  - iATR(NULL, 0, ATRperiod, i),Trend[i+1]); Direction[i] =  1; }
            if (cciTrend < 0) { Trend[i] = MathMin(High[i] + iATR(NULL, 0, ATRperiod, i),Trend[i+1]); Direction[i] = -1; }
            if (!noIntermediate)
            {
               if (Direction[i]==-1 && Direction[i+1]==-1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
               if (Direction[i]== 1 && Direction[i+1]== 1) PlotPoint(i,TrendUpA,TrendUpB,Trend);
            }
            else
            {
               if (Direction[i] == -1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
               if (Direction[i] ==  1) PlotPoint(i,TrendUpA,TrendUpB,Trend);
            }         
      }
      manageAlerts();
      return(0);
   }      

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (!noIntermediate)
      {
         if (Direction[limit] == -1 && Direction[limit+1] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
         if (Direction[limit] ==  1 && Direction[limit+1] ==  1) CleanPoint(limit,TrendUpA,TrendUpB);
      }
      else
      {
         if (Direction[limit] == -1) CleanPoint(limit,TrendDoA,TrendDoB);
         if (Direction[limit] ==  1) CleanPoint(limit,TrendUpA,TrendUpB);
      }         
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      TrendDoA[i]  = EMPTY_VALUE;
      TrendDoB[i]  = EMPTY_VALUE;
      TrendUpA[i]  = EMPTY_VALUE;
      TrendUpB[i]  = EMPTY_VALUE;
      Trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCIperiod,ATRperiod,applied_price,noIntermediate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
      Direction[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCIperiod,ATRperiod,applied_price,noIntermediate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y);
      int pDir     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",CCIperiod,ATRperiod,applied_price,noIntermediate,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y+1);
         if (!noIntermediate)
         {
            if (Direction[i]==-1 && pDir==-1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
            if (Direction[i]== 1 && pDir== 1) PlotPoint(i,TrendUpA,TrendUpB,Trend);
         }
         else
         {
            if (Direction[i] == -1) PlotPoint(i,TrendDoA,TrendDoB,Trend);
            if (Direction[i] ==  1) PlotPoint(i,TrendUpA,TrendUpB,Trend);
         }         
   }
   return(0);         
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;
      
      //
      //
      //
      //
      //
      
      if (noIntermediate)
      {
         if (Direction[forBar]!=Direction[forBar+1])
         {
            if (Direction[forBar]== 1 && Direction[forBar+1]== 1) doAlert(0,"up");
            if (Direction[forBar]==-1 && Direction[forBar+1]==-1) doAlert(0,"down");
         }            
      }
      else
      {
         if (Direction[forBar]==Direction[forBar+1] && Direction[forBar]!=Direction[forBar+2])
         {
            if (Direction[forBar]== 1) doAlert(0,"up");
            if (Direction[forBar]==-1) doAlert(0,"down");
         }            
      }         
   }
} 

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" super trend to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," super strength"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}